#include "legend.hpp"

void Legend::Center(BOX_TYPE* box, COLOR_TYPE color,
		    char* legend1, char* legend2)
{
	// compute width and height of area where text will go
	int width  = box->x2 - box->x1;
	int height = box->y2 - box->y1;

	// look up the size of each character
	int c_width  = GraphicsHandler->FontWidth();
	int c_height = GraphicsHandler->FontHeight();

	char* string [3];
	string [0] = legend1;
	string [1] = legend2;

	// determine actual number of arguments
	int legends;
	if (legend2)
	  legends = 2;
	else
	  legends = 1;

	for (int i = 0; i < legends; i++) {
	  int x = box->x1 + \
			(width - c_width * strlen(string [i]) ) / 2;
	  int y = box->y1 + \
			(legends - i) * \
			height / (legends + 1) - c_height / 2;
	  GraphicsHandler->PutString(color, x, y, string [i]);
	}
}

void Legend::Left(BOX_TYPE* box, COLOR_TYPE color,
		    char* legend1, char* legend2)
{
	// compute width and height of area where text will go
	int height = box->y2 - box->y1;

	// look up the size of each character
	int c_height = GraphicsHandler->FontHeight();

	char *string [3];
	string [0] = legend1;
	string [1] = legend2;

	// determine actual number of arguments
	int legends;
	if (legend2)
	  legends = 2;
	else
	  legends = 1;

	for (int i = 0; i < legends; i++) {
	  int x = box->x1;
	  int y = box->y1 + \
			(legends - i) * \
			height / (legends + 1) - c_height / 2;
	  GraphicsHandler->PutString(color, x, y, string [i]);
	}
}

void Legend::Right(BOX_TYPE* box, COLOR_TYPE color,
		    char* legend1, char* legend2)
{

	// compute width and height of area where text will go
	int width  = box->x2 - box->x1;
	int height = box->y2 - box->y1;

	// look up the size of each character
	int c_width  = GraphicsHandler->FontWidth() + 1;
	int c_height = GraphicsHandler->FontHeight();

	char *string [3];
	string [0] = legend1;
	string [1] = legend2;

	// determine actual number of arguments
	int legends;
	if (legend2)
	  legends = 2;
	else
	  legends = 1;

	for (int i = 0; i < legends; i++) {
	  int x = box->x1 + \
			width - c_width * strlen(string [i]);
	  int y = box->y1 + \
			(legends - i) * \
			height / (legends + 1) - c_height / 2;
	  GraphicsHandler->PutString(color, x, y, string [i]);
	}
}
